{{ $appName := (index . "Values" "name") -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName | quote }}
  labels:
    {{- include "varnish.labels" . | nindent 4 }}
spec:
{{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
{{- end }}
  selector:
    matchLabels:
      {{- include "varnish.selectorLabels" . | nindent 6 }}
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  template:
    metadata:
      labels:
        {{- include "varnish.selectorLabels" . | nindent 8 }}
      annotations:
      {{- if .Values.vcl }}
        checksum/vclConfig: {{ toJson .Values.vcl | sha256sum }}
      {{- end }}
    spec:
      automountServiceAccountToken: false
      containers:
        - name: varnishd
          image: {{ include "varnish.image" . }}
          securityContext:
            capabilities:
              drop:
                - ALL
            readOnlyRootFilesystem: true
            runAsNonRoot: true
            runAsUser: 1000
          imagePullPolicy: IfNotPresent
          env:
            - name: VARNISH_SIZE
              value: {{ .Values.varnishSize |quote  }}
            - name: VARNISH_HTTP_PORT
              value: "8080"
          {{- if .Values.arguments }}
          args:
            {{- range .Values.arguments }}
              - {{ . }}
            {{- end }}
          {{- end }}
          ports:
            - name: http
              containerPort: 8080
              protocol: TCP
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
          - name: disk-cache
            mountPath: /var/lib/varnish/varnishd
          {{- if .Values.vcl }}
          - name: vcl-configmap
            mountPath: /etc/varnish
          {{- end }}
          {{- with .Values.livenessProbe }}
          livenessProbe:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with .Values.readinessProbe }}
          readinessProbe:
            {{- toYaml . | nindent 12 }}
          {{- end }}

      volumes:
      - name: disk-cache
        emptyDir: {}
      {{- if .Values.vcl }}
      - name: vcl-configmap
        configMap:
          name: {{ include "varnish.fullname" . }}
      {{- end }}

